DEFAULT = n

ifeq ("$(OPT_TYPE)","SIZE")
DEBUG=-O3 -fno-inline -fno-tree-loop-optimize
else
DEBUG=-O3 -funroll-loops -finline-limit=20000 -fno-tree-loop-optimize
endif

MEMSIZE     = 0x100000
LOADADDR    = 0x0

CFLAGS     += -DDEBUG_MODE_WATCH_EXCEPTION -DMEMSIZE=$(MEMSIZE) -mno-gpopt -G0

# -----------------------------------------------------------------------
# Compiler, Architecture, ABI etc.
# -----------------------------------------------------------------------

ABI         = 32

# -----------------------------------------------------------------------
# If no ABI is given, default to O32
# -----------------------------------------------------------------------

ifeq ("$(ABI)","")
CPUFLAGS += -mabi=32 -march=mips32r2
else
CPUFLAGS += -mabi=$(ABI) -march=mips32r2
endif

OBJ_FORMAT  = elf32-tradbigmips         # Emulation for the ELF Toolchain

TARGET   = mipsisa64r2-nlm-elf

CUT		 = cut
SED		 = sed

HOSTCC	 = gcc
CC       = $(TARGET)-gcc
AR       = $(TARGET)-ar
AS       = $(TARGET)-gcc
LD       = $(TARGET)-ld
NM       = $(TARGET)-nm
OBJCOPY  = $(TARGET)-objcopy
OBJDUMP  = $(TARGET)-objdump
READELF  = $(TARGET)-readelf
SIZE     = $(TARGET)-size
STRIP	 = $(TARGET)-strip

# -----------------------------------------------------------------------
# All CFLAGS to be used...
# -----------------------------------------------------------------------
CFLAGS += $(CPUFLAGS) #-O0
CFLAGS += -fomit-frame-pointer -mno-branch-likely $(DEBUG)
CFLAGS += -fno-pic -mno-abicalls -ffunction-sections -fdata-sections
CFLAGS += -DLOADADDR=$(LOADADDR) -D_KERNEL
CFLAGS += -Wall

LIBS += -L$(BASEDIR)/newlib

INCLUDES += -I/. -I$(BASEDIR)/include

# -----------------------------------------------------------------------
# NEWLIB
# -----------------------------------------------------------------------

NEWLIB_ROOT=$(BASEDIR)/newlib

GCC_FLOAT			=

CFLAGS    += $(INCLUDES) $(GCC_FLOAT) -O3
ASFLAGS   += $(CFLAGS) -D__ASSEMBLY__ $(GCC_FLOAT)

LINKER_SCRIPT=ld.phoenix.s

LINKFLAGS += -T$(LINKER_SCRIPT) $(LIBS)
LINKFLAGS +=  -G0

ifeq ("$(DEFAULT)", "y")
CRT0        =
CRTI        = 
CRTEND		=
CRTN		=
else
CRT0        = $(NEWLIB_ROOT)/crt0_basic.o
CRTI        = $(shell $(CC) $(CPUFLAGS) $(GCC_FLOAT) --print-file-name=crti.o)
CRTEND      = $(shell $(CC) $(CPUFLAGS) $(GCC_FLOAT) --print-file-name=crtend.o)
CRTN        = $(shell $(CC) $(CPUFLAGS) $(GCC_FLOAT) --print-file-name=crtn.o)
endif

#
# libgcc/libstdc++ from GCC toolchain
#
LIBGCC 	  = $(shell $(CC) $(CPUFLAGS) $(GCC_FLOAT) -print-libgcc-file-name)

# -----------------------------------------------------------------------
# All libraries needed
# ----------------------------------------------------------------------

LIBS_START     = $(CRT0) $(CRTI) --start-group
LIBS_END       = $(LIBGCC) --end-group $(CRTEND) $(CRTN)

.PHONY:
