/* Example code for uCore */
#include <stdint.h>

#include "ucore.h"

int main(void)
{
	uint32_t rx_pkt_ready = 0;
	int intf = 0;
	int hw_parser_error = 0;
	int context = 0;
	int n_cachelines = 1518 >> 6; /* Number of cachelines in Eth MTU */

	for (;;) {
		rx_pkt_ready = wait_for_packet();

		/* parsed values are not used! */
		intf = rx_pkt_ready & 0x1f;
		context = (rx_pkt_ready >> 13) & 0x3ff;
		hw_parser_error = (rx_pkt_ready >> 23) & 0x1;

		packet_dist( VAL_PDL(0) | VAL_PDM(FWD_DIST_VEC));

		packet_done(n_cachelines << 20);
	}

	/* should never come here */
	return 0;
}
