ENTRY(_start)
OUTPUT_FORMAT(OBJ_FORMAT)
__DYNAMIC  =  0;

SECTIONS
{
  . = LOADADDR;
  _loadaddr = .	;
  
  /* ----------------------------------------- */

  .text : {
    _ftext = . ;
    PROVIDE (eprol = .);
    _shim_reg = . ;
    *(.text)
    *(.text.*)
    *(.gnu.linkonce.t*)
    *(.mips16.fn.*)
    *(.mips16.call.*)
  }
  .init : {
    KEEP(*(.init))
    *(.init)
  }
  .fini : {
    *(.fini)
  }
  .rel.sdata : {
    PROVIDE (__runtime_reloc_start = .);
    *(.rel.sdata)
    PROVIDE (__runtime_reloc_stop = .);
  }
  PROVIDE (etext = .);
  .ctors    :
  {
    KEEP (*crtbegin.o(.ctors))
    KEEP (*(EXCLUDE_FILE (*crtend.o) .ctors))
    KEEP (*(SORT(.ctors.*)))
    KEEP (*(.ctors))
  }
  .dtors    :
  {
    KEEP (*crtbegin.o(.dtors))
    KEEP (*(EXCLUDE_FILE (*crtend.o) .dtors))
    KEEP (*(SORT(.dtors.*)))
    KEEP (*(.dtors))
  }
  . = .;
  .rodata : {
    *(.rdata)
    *(.rodata)
    *(.rodata.*)
    *(.gnu.linkonce.r*)
  }
  . = . + (0x1000 - .) ;

  /* ----------------------------------------- */
  
  . = 0x8000 ;
  magicstart = . ;
  .magicregs : {
	*(.magicregs)
  }
  magicend = . ;
  
  /* ----------------------------------------- */
  
  . = 0x18000 ; 		
  shmemstart = . ;
  .sharedmem : {
	*(.sharedmem)
  }
  shmemend = . ;
  
  /* ----------------------------------------- */
  
  . = 0xFF800 ;
  .data : {
    *(.data)
    *(.data.*)
    *(.gnu.linkonce.d*)
  }
  . = ALIGN(8);
  .lit8 : {
    *(.lit8)
  }
  .lit4 : {
    *(.lit4)
  }
  .sdata : {
    *(.sdata)
    *(.sdata.*)
    *(.gnu.linkonce.s*)
  }
  . = ALIGN (8);
   PROVIDE (edata  =  .);
   _edata  =  .;
   _fbss = .;
  .sbss : {
    *(.sbss)
    *(.scommon)
  }
  .bss : {
    _bss_start = . ;
    *(.bss)
    *(COMMON)
  }
  _bss_end = . ;
  _end = .;

  _gp = . ;
  __global = _gp ;
  . = ALIGN (8);
  
  PROVIDE(__stackmarker = .) ;

  . = 0xFFA00 ;	

  /* 32 + 4(argc) + 4(argv), aligned to 64 */
  PROVIDE(__stack =  . - 64); 

  /* ----------------------------------------- */

  . = 0xFFE00 ;
  .pktbuf : {
	*(.pktbuf)
  }
  . = . + (0x100000 - .) ;

  PROVIDE(_endaddr = LOADADDR + MEMSIZE);
}
