/* Example code for uCore */
#include <stdint.h>

#define PACKET_MEMORY       (0xFFE00)
#define PACKET_DATA_OFFSET  (64)

static __inline__ void packet_done(uint32_t ucore_outbuf_done) {
	__asm__ volatile (
		"li	$8, 0x8000\n"
		"sw	%0, ($8)\n"
		:
		: "r"(ucore_outbuf_done)
		: "$8"
		);
}

static __inline__ void packet_dist(uint32_t pkt_dist) {
	__asm__ volatile (
		"li	$8, 0x8030\n"
		"sw	%0, ($8)\n"
		:
		: "r"(pkt_dist)
		: "$8"
		);
}

static __inline__ uint32_t ld_packet_dist(void) {
    uint32_t dist;

	__asm__ volatile (
		"li	$8, 0x8030\n"
		"lw	%0, ($8)\n"
		: "=r"(dist)
		: 
		: "$8"
		);
return dist;

}

static __inline__ uint32_t wait_for_packet(void) {
	uint32_t ucore_rx_pkt_rdy;
	__asm__ volatile (
		"li	$8, 0x8004\n"
		"lw	%0, ($8)\n"
		: "=r"(ucore_rx_pkt_rdy)
		:
		: "$8"
		);
	return ucore_rx_pkt_rdy;
}
static __inline__ uint32_t write_reg(uint32_t reg_num, uint32_t val) {
    uint32_t *reg = (uint32_t *) reg_num;
    return  ( *reg = val);
}

#define UCORE_PKT_DIST          0x8030
#define VAL_DEST(x)         (x & 0x3ff)<<8
#define VAL_PDM(x)          (x & 0x7)

int main(void) {
	uint32_t *pkt_data32 = (uint32_t *)(PACKET_MEMORY + PACKET_DATA_OFFSET);
//    uint32_t *ucore_pkt_dist = (uint32_t *) UCORE_PKT_DIST;
    
	for (;;) {
		wait_for_packet();
    #if 0    
		pkt_data32[10] = 0xbeebdead;
		pkt_data32[11] = 0xdeadbeeb;
		pkt_data32[12] = 0xdeadbeeb;
		pkt_data32[13] = 0xbeebdead;
    #endif
        packet_dist(VAL_PDM(1)|VAL_DEST(0));


      //        *ucore_pkt_dist = VAL_DEST(0)|VAL_PDM(1);
      //   pkt_data32[11] = ld_packet_dist(); 
      //	pkt_data32[12] = *ucore_pkt_dist;
		packet_done(0);
	}

	/* should never come here */
	return 0;
}
