#ifndef _UCORE_H
#define _UCORE_H

#define PACKET_MEMORY       (0xFFE00)
#define PACKET_DATA_OFFSET  (64)

static __inline__ void packet_done(uint32_t ucore_outbuf_done)
{
	__asm__ volatile (
		"li	$8, 0x8000\n"
		"sw	%0, ($8)\n"
		:
		: "r"(ucore_outbuf_done)
		: "$8"
		);
}

static __inline__ void packet_dist(uint32_t pkt_dist)
{
	__asm__ volatile (
		"li	$8, 0x8030\n"
		"sw	%0, ($8)\n"
		:
		: "r"(pkt_dist)
		: "$8"
		);
}

static __inline__ uint32_t ld_packet_dist(void)
{
	uint32_t dist;

	__asm__ volatile (
		"li	$8, 0x8030\n"
		"lw	%0, ($8)\n"
		: "=r"(dist)
		:
		: "$8"
		);
	return dist;

}

static __inline__ uint32_t wait_for_packet(void)
{
	uint32_t ucore_rx_pkt_rdy;

	__asm__ volatile (
		"li	$8, 0x8004\n"
		"lw	%0, ($8)\n"
		: "=r"(ucore_rx_pkt_rdy)
		:
		: "$8"
		);
	return ucore_rx_pkt_rdy;
}

/* Distribution mode */
#define VAL_PDM(x)          (((x) & 0x7) << 0)

/* Dest distribution or distribution list */
#define VAL_DEST(x)         (((x) & 0x3ff) << 8)
#define VAL_PDL(x)          (((x) & 0xf) << 4)

#define FWD_DEST_ONLY 1
#define FWD_DIST_VEC  4

#endif /* _UCORE_H */
